rmsaov.test = function(matname) 
{
    s <- dim(matname)[1]
    df.subjects <- s - 1
    a <- dim(matname)[2]
    df.treatment <- a - 1
    total.df <- a * s - 1
    total.SS <- var(as.vector(matname)) * total.df
    treatment.SS <- var(margin.table(matname, 2)) * df.treatment/s
    treatment.MS <- treatment.SS/df.treatment
    subjects.SS <- var(margin.table(matname, 1)) * df.subjects/a
    subjects.MS <- subjects.SS/df.subjects
    error.SS <- total.SS - treatment.SS - subjects.SS
    df.error <- df.treatment * df.subjects
    error.MS <- error.SS/df.error
    STATISTIC <- treatment.MS/error.MS
    PARAMETER <- c(df.treatment, df.error)
    PVAL <- pf(STATISTIC, df.treatment, df.error, lower.tail = FALSE)
    DNAME <- deparse(substitute(matname))
    METHOD <- "Oneway ANOVA with repeated measures"
    names(STATISTIC) <- "F"
    names(PARAMETER) <- c("df treat", "df error")
    OUT <- list(statistic = STATISTIC, parameter = PARAMETER, 
        p.value = PVAL, method = METHOD, data.name = DNAME, MS.treatment = treatment.MS, 
        MS.error = error.MS, MS.subjects = subjects.MS)
    class(OUT) <- "htest"
    print(OUT)
    print(c(MS.error = error.MS, MS.treat = treatment.MS, MS.subjs = subjects.MS))
    cat("\n")
    cat("Treatment Means\n")
    print(apply(matname, 2, mean))
    cat("\n")
    cat("Compound Symmetry Check (Variance-Covariance Matrix)\n")
    covmat <- cov(matname)
    print(covmat)
    cat("\n")
    cat("Estimated Greenhouse-Geisser Epsilon and Adjusted p-value\n")
    D <- a^2 * (mean(diag(covmat)) - mean(covmat))^2
    N1 <- sum(covmat^2)
    N2 <- 2 * a * sum(apply(covmat, 1, mean)^2)
    N3 <- a^2 * mean(covmat)^2
    epsilon <- D/((a - 1) * (N1 - N2 + N3))
    p.adj <- pf(treatment.MS/error.MS, df.treatment * epsilon, 
        df.error * epsilon, lower.tail = FALSE)
    GGE <- c(epsilon, p.adj)
    names(GGE) = c("epsilon", "p-adjust")
    print(GGE)
}